/* $Id: object.h,v 1.3 2001/05/21 09:58:53 malekith Exp $ */

#ifndef YTK_INT_OBJECT_H
#define YTK_INT_OBJECT_H

#include <yw/window.h>
#include <ytk/context.h>

typedef struct YtkClass_struct YtkClass;

struct YtkClass_struct {
	YtkClass *next;
	char *name;
	YtkCreator creator;
	void *creator_data;
	
	int refcnt;
};

struct YtkObject_struct {
	YtkObject *next;
	YtkObject *children;
	YtkObject *last_child;
	YtkObject *active;
	YtkObject *parent;
	YwWindow *window;
	
	YtkCallback callback;
	YtkFree finalizer;
	
	YtkClass *klass;
	void *data;
	int refcnt;
	
	YtkContext *context;
};

#endif /* YTK_INT_OBJECT_H */
